using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace palindromo
{
    class Program
    {
        public int Solve(int N, int M, int X, int Y, int[] A, int[] B, char[] L)
        {

            // aggiungi codice...
            var risposta = 42;

            return risposta;
        }
        
        public void Run()
        {
            // se preferisci leggere e scrivere da file
            // ti basta modificare la seguente variabile
            bool input_from_file = false;

            if (input_from_file) {
                streamReader = new StreamReader("input.txt");
                streamWriter = new StreamWriter("output.txt");
            } else {
                streamReader = new StreamReader(Console.OpenStandardInput());
                streamWriter = new StreamWriter(Console.OpenStandardOutput());
            }

            iterator = GetEnumerator(streamReader);

            int T = NextInt();

            for (int t = 1; t <= T; t++) {
                int N = NextInt();
                int M = NextInt();
                int X = NextInt();
                int Y = NextInt();

                int[] A = new int[M];
                int[] B = new int[M];
                char[] L = new char[M];
                
                for (int i = 0; i < M; i++) {
                    A[i] = NextInt();
                    B[i] = NextInt();
                    L[i] = NextToken()[0];
                }

                int res = Solve(N, M, X, Y, A, B, L);
                streamWriter.WriteLine($"Case #{t}: {res}");
                streamWriter.Flush();
            }

            streamReader.Close();
            streamWriter.Close();
        }

        public IEnumerator<String> GetEnumerator(StreamReader sr)
        {
            String line;
            while ((line = sr.ReadLine()) != null) {
                String[] tokens = line.Split(' ').Where(t => t.Length > 0).ToArray();
                foreach (String t in tokens) {
                    yield return t;
                }
            }
        }

        public String NextToken()
        {
            iterator.MoveNext();
            return iterator.Current;  
        }

        public int NextInt()
        {
            return Convert.ToInt32(NextToken());
        }
        
        static void Main(String[] args)
        {
            var program = new Program();
            program.Run();
        }
        
        private StreamReader streamReader;
        private StreamWriter streamWriter;
        private IEnumerator<String> iterator;
    }
}
